import React, { PropTypes } from 'react';
import purebem from 'purebem';

import { pgettext } from '../../../utils/lang';

import './FoundationFormErrors.less';


const block = purebem.of('foundation-form-errors');

const FoundationFormErrors = React.createClass({

    propTypes: {
        className: PropTypes.string,
        errors: PropTypes.object
    },

    getDefaultProps() {
        return {
            errors: {}
        };
    },

    renderErrors() {
        const singleError = Object.keys(this.props.errors).length === 1;
        return Object.keys(this.props.errors).map((key) => {
            return (
                <li key={ key } className={ block('errors', { singleError }) }>
                    { pgettext('form field error field', key) } { '-' } { pgettext('action-form-errors', this.props.errors[key].join(', ')) }
                </li>
            );
        });
    },

    render() {
        if (Object.keys(this.props.errors).length === 0) {
            return null;
        }

        return (
            <div className={ block() }>
                <ul className={ block('list') }>
                    { this.renderErrors() }
                </ul>
            </div>
        );
    }

});

export default FoundationFormErrors;
