import React, { PropTypes } from 'react';
import onClickOutside from 'react-onclickoutside';


const FoundationClickOutside = React.createClass({

    propTypes: {
        children: PropTypes.node,
        onClick: PropTypes.func
    },

    getDefaultProps() {
        return {
            children: null,
            onClick: () => {}
        };
    },

    componentDidMount() {
        document.addEventListener('keyup', this.onKeyUp);
    },

    componentWillUnmount() {
        document.removeEventListener('keyup', this.onKeyUp);
    },

    onKeyUp(evt) {
        if (evt.keyCode === 27) {
            this.props.onClick();
        }
    },

    handleClickOutside() {
        this.props.onClick();
    },

    render() {
        return this.props.children;
    }

});

export default onClickOutside(FoundationClickOutside);
