import textboxTextState from './textboxTextState';


test('should have sensible defaults', () => {
    const state = textboxTextState();
    expect(state).toEqual({ focus: false, rawValue: '', value: '' });
});

test('should set rawValue when setting value', () => {
    const state = textboxTextState({ value: 'a' });
    expect(state).toEqual({ focus: false, rawValue: 'a', value: 'a' });
});

test('should convert numeric value to string', () => {
    const state = textboxTextState({ value: 1 });
    expect(state).toEqual({ focus: false, rawValue: '1', value: '1' });
});

test('empty string if null', () => {
    const state = textboxTextState({ value: null });
    expect(state).toEqual({ focus: false, rawValue: '', value: '' });
});

test('empty string if undefined', () => {
    const state = textboxTextState({ value: void(0) });
    expect(state).toEqual({ focus: false, rawValue: '', value: '' });
});
